# coding: utf-8

# flake8: noqa

"""
    h2oGPTe REST API

     # Overview   Users can easily interact with the h2oGPTe API through its REST API, allowing HTTP requests from any programming language.  ## Authorization: Getting an API key  Sign up/in at Enterprise h2oGPTe and generate one of the following two types of API keys:   - **Global API key**: If a Collection is not specified when creating a new API Key, that key is considered to be a global API Key. Use global API Keys to grant full user impersonation and system-wide access to all of your work. Anyone with access to one of your global API Keys can create, delete, or interact with any of your past, current, and future Collections, Documents, Chats, and settings.  - **Collection-specific API key**: Use Collection-specific API Keys to grant external access to only Chat with a specified Collection and make related API calls to it. Collection-specific API keys do not allow other API calls, such as creation, deletion, or access to other Collections or Chats.   Access Enterprise h2oGPTe through your [H2O Generative AI](https://genai.h2o.ai/appstore) app store account, available with a freemium tier.  ## Authorization: Using an API key   All h2oGPTe REST API requests must include an API Key in the \"Authorization\" HTTP header, formatted as follows:  ``` Authorization: Bearer sk-XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX ```  ```sh curl -X 'POST' \\   'https://h2ogpte.genai.h2o.ai/api/v1/collections' \\   -H 'accept: application/json' \\   -H 'Content-Type: application/json' \\   -H 'Authorization: Bearer sk-XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX' \\   -d '{     \"name\": \"The name of my Collection\",     \"description\": \"The description of my Collection\",     \"embedding_model\": \"BAAI/bge-large-en-v1.5\"   }' ```      ## Interactive h2oGPTe API testing  This page only showcases the h2oGPTe REST API; you can test it directly in the [Swagger UI](https://h2ogpte.genai.h2o.ai/swagger-ui/). Ensure that you are logged into your Enterprise h2oGPTe account. 

    The version of the OpenAPI document: v1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


__version__ = "1.6.28.post1"

# import apis into sdk package
from h2ogpte.rest.api.api_keys_api import APIKeysApi
from h2ogpte.rest.api.chat_api import ChatApi
from h2ogpte.rest.api.collections_api import CollectionsApi
from h2ogpte.rest.api.document_ingestion_api import DocumentIngestionApi
from h2ogpte.rest.api.documents_api import DocumentsApi
from h2ogpte.rest.api.jobs_api import JobsApi
from h2ogpte.rest.api.models_api import ModelsApi
from h2ogpte.rest.api.permissions_api import PermissionsApi
from h2ogpte.rest.api.prompt_templates_api import PromptTemplatesApi
from h2ogpte.rest.api.tags_api import TagsApi

# import ApiClient
from h2ogpte.rest.api_response import ApiResponse
from h2ogpte.rest.api_client import ApiClient
from h2ogpte.rest.configuration import Configuration
from h2ogpte.rest.exceptions import OpenApiException
from h2ogpte.rest.exceptions import ApiTypeError
from h2ogpte.rest.exceptions import ApiValueError
from h2ogpte.rest.exceptions import ApiKeyError
from h2ogpte.rest.exceptions import ApiAttributeError
from h2ogpte.rest.exceptions import ApiException

# import models into sdk package
from h2ogpte.rest.models.api_key_create_request import APIKeyCreateRequest
from h2ogpte.rest.models.api_key_info import APIKeyInfo
from h2ogpte.rest.models.api_key_result import APIKeyResult
from h2ogpte.rest.models.api_key_update_expiry_request import APIKeyUpdateExpiryRequest
from h2ogpte.rest.models.azure_credentials import AzureCredentials
from h2ogpte.rest.models.chat_completion import ChatCompletion
from h2ogpte.rest.models.chat_completion_delta import ChatCompletionDelta
from h2ogpte.rest.models.chat_completion_request import ChatCompletionRequest
from h2ogpte.rest.models.chat_error import ChatError
from h2ogpte.rest.models.chat_message import ChatMessage
from h2ogpte.rest.models.chat_message_meta import ChatMessageMeta
from h2ogpte.rest.models.chat_message_reference import ChatMessageReference
from h2ogpte.rest.models.chat_session import ChatSession
from h2ogpte.rest.models.chat_session_update_request import ChatSessionUpdateRequest
from h2ogpte.rest.models.chat_settings import ChatSettings
from h2ogpte.rest.models.collection import Collection
from h2ogpte.rest.models.collection_change_request import CollectionChangeRequest
from h2ogpte.rest.models.collection_create_request import CollectionCreateRequest
from h2ogpte.rest.models.collection_settings import CollectionSettings
from h2ogpte.rest.models.collection_update_request import CollectionUpdateRequest
from h2ogpte.rest.models.count import Count
from h2ogpte.rest.models.document import Document
from h2ogpte.rest.models.document_update_request import DocumentUpdateRequest
from h2ogpte.rest.models.endpoint_error import EndpointError
from h2ogpte.rest.models.gcs_credentials import GCSCredentials
from h2ogpte.rest.models.guardrails_settings import GuardrailsSettings
from h2ogpte.rest.models.ingest_from_azure_blob_storage_body import IngestFromAzureBlobStorageBody
from h2ogpte.rest.models.ingest_from_file_system_body import IngestFromFileSystemBody
from h2ogpte.rest.models.ingest_from_gcs_body import IngestFromGcsBody
from h2ogpte.rest.models.ingest_from_s3_body import IngestFromS3Body
from h2ogpte.rest.models.ingest_from_website_body import IngestFromWebsiteBody
from h2ogpte.rest.models.ingest_upload_body import IngestUploadBody
from h2ogpte.rest.models.job_details import JobDetails
from h2ogpte.rest.models.job_details_status import JobDetailsStatus
from h2ogpte.rest.models.model import Model
from h2ogpte.rest.models.model_usage_stats_per_user import ModelUsageStatsPerUser
from h2ogpte.rest.models.performance_stats_per_model import PerformanceStatsPerModel
from h2ogpte.rest.models.prompt_template import PromptTemplate
from h2ogpte.rest.models.prompt_template_base import PromptTemplateBase
from h2ogpte.rest.models.prompt_template_change_request import PromptTemplateChangeRequest
from h2ogpte.rest.models.prompt_template_create_request import PromptTemplateCreateRequest
from h2ogpte.rest.models.role_create_request import RoleCreateRequest
from h2ogpte.rest.models.role_info import RoleInfo
from h2ogpte.rest.models.s3_credentials import S3Credentials
from h2ogpte.rest.models.share_permission import SharePermission
from h2ogpte.rest.models.suggested_question import SuggestedQuestion
from h2ogpte.rest.models.tag import Tag
from h2ogpte.rest.models.tag_create_request import TagCreateRequest
from h2ogpte.rest.models.tag_update_request import TagUpdateRequest
from h2ogpte.rest.models.uploaded_file import UploadedFile
from h2ogpte.rest.models.usage_stats import UsageStats
from h2ogpte.rest.models.usage_stats_per_model import UsageStatsPerModel
from h2ogpte.rest.models.usage_stats_per_model_and_user import UsageStatsPerModelAndUser
from h2ogpte.rest.models.usage_stats_per_user import UsageStatsPerUser
from h2ogpte.rest.models.user_info import UserInfo
from h2ogpte.rest.models.user_permission import UserPermission
